/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.viewers.HapticViewer3D.gui;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.visnow.vn.lib.basic.viewers.HapticViewer3D.controller.InputDevicePointerController;
import org.visnow.vn.lib.basic.viewers.HapticViewer3D.controller.pointer3d.Pointer3DViewBehavior;

/**
 * JPanel with haptic options. It consists of two tabs: Display and Haptics.
 * Display tab is defined here, while Haptics tab is defined in HapticGUI.form and HapticGUI.java.
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 * @author modified by Łukasz Czerwiński <czerwinskilukasz1 [#] gmail.com>, ICM, University of
 * Warsaw, 2013
 */
public class GUI extends javax.swing.JPanel implements Pointer3DViewBehavior.PointerStateListener
{

    static final org.apache.log4j.Logger logger
        = org.apache.log4j.Logger.getLogger(new Throwable().getStackTrace()[0].getClassName());
    Map<InputDevicePointerController, DeviceGUITab> deviceTabs
        = new HashMap<InputDevicePointerController, DeviceGUITab>();
    HapticViewer3D viewer;

    /**
     * Creates new form GUI
     */
    public GUI(HapticViewer3D viewer)
    {
        this.viewer = viewer;

        initComponents();
    }

    public void createDeviceTab(InputDevicePointerController deviceController)
    {

        String tabCaption = deviceController.getDevice().getDeviceFriendlyName();

        DeviceGUITab tab = DeviceGUITab.createDeviceTab(deviceController);
        jTabbedPane1.addTab(tabCaption, tab);
        deviceTabs.put(deviceController, tab);
    }

    void removeDeviceTab(InputDevicePointerController controller)
    {
        DeviceGUITab tab = deviceTabs.get(controller);
        jTabbedPane1.remove(tab);
        tab.close(); // uninitialize tab
        deviceTabs.remove(controller);
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        devicesCheckboxesGUIBeanInfo1 = new org.visnow.vn.lib.basic.viewers.HapticViewer3D.gui.DevicesCheckboxesGUIBeanInfo();
        devicesCheckboxesGUIBeanInfo2 = new org.visnow.vn.lib.basic.viewers.HapticViewer3D.gui.DevicesCheckboxesGUIBeanInfo();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        activeDevicesPanel = new javax.swing.JPanel();
        devicesCheckboxesGUI1 = new org.visnow.vn.lib.basic.viewers.HapticViewer3D.gui.DevicesListGUI(this.viewer);
        jButton1 = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        pickingStateLabel = new javax.swing.JLabel();
        loosePointerLabel = new javax.swing.JLabel();
        counterLabel = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();

        setMinimumSize(new java.awt.Dimension(200, 0));
        setPreferredSize(new java.awt.Dimension(200, 400));

        activeDevicesPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createTitledBorder("Select active pointer device(s):")));
        activeDevicesPanel.setPreferredSize(new java.awt.Dimension(250, 0));

        devicesCheckboxesGUI1.setPreferredSize(new java.awt.Dimension(250, 0));

        javax.swing.GroupLayout activeDevicesPanelLayout = new javax.swing.GroupLayout(activeDevicesPanel);
        activeDevicesPanel.setLayout(activeDevicesPanelLayout);
        activeDevicesPanelLayout.setHorizontalGroup(
                activeDevicesPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addComponent(devicesCheckboxesGUI1, javax.swing.GroupLayout.DEFAULT_SIZE, 0, Short.MAX_VALUE)
                );
        activeDevicesPanelLayout.setVerticalGroup(
                activeDevicesPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addComponent(devicesCheckboxesGUI1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                );

        jButton1.setText("Show display frame");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jLabel1.setText("\"Emergency brake\"");

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel2.setText("<html>In case of any problems with active devices (with force feedback), remember that pressing Space or Enter in ANY VisNow window IMMEDIATELY disables ALL forces.</html>");
        jLabel2.setVerticalAlignment(javax.swing.SwingConstants.TOP);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
                jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(jPanel1Layout.createSequentialGroup()
                                .addContainerGap()
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE)
                                        .addComponent(jButton1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(activeDevicesPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 175, Short.MAX_VALUE)
                                        .addGroup(jPanel1Layout.createSequentialGroup()
                                                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 169, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                        .addComponent(counterLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                        .addComponent(loosePointerLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                        .addComponent(pickingStateLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
                                .addContainerGap())
                );
        jPanel1Layout.setVerticalGroup(
                jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(jPanel1Layout.createSequentialGroup()
                                .addContainerGap()
                                .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 41, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(activeDevicesPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 38, Short.MAX_VALUE)
                                .addGap(18, 18, 18)
                                .addComponent(counterLabel)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addGroup(jPanel1Layout.createSequentialGroup()
                                                .addGap(7, 7, 7)
                                                .addComponent(pickingStateLabel)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(loosePointerLabel)
                                                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                        .addGroup(jPanel1Layout.createSequentialGroup()
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(jLabel1)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 83, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                .addGap(0, 144, Short.MAX_VALUE))))
                );

        jTabbedPane1.addTab("Display", jPanel1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addComponent(jTabbedPane1)
                );
        layout.setVerticalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 400, Short.MAX_VALUE)
                );
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        fireStateChanged();
    }//GEN-LAST:event_jButton1ActionPerformed

    /**
     * Utility field holding list of ChangeListeners.
     */
    private transient ArrayList<ChangeListener> changeListenerList
        = new ArrayList<ChangeListener>();

    /**
     * Registers ChangeListener to receive events.
     *
     * @param listener The listener to register.
     */
    public synchronized void addChangeListener(ChangeListener listener)
    {
        changeListenerList.add(listener);
    }

    /**
     * Removes ChangeListener from the list of listeners.
     *
     * @param listener The listener to remove.
     */
    public synchronized void removeChangeListener(ChangeListener listener)
    {
        changeListenerList.remove(listener);
    }

    /**
     * Notifies all registered listeners about the event.
     *
     * @param object Parameter #1 of the <CODE>ChangeEvent<CODE> constructor.
     */
    private void fireStateChanged()
    {
        ChangeEvent e = new ChangeEvent(this);

        for (ChangeListener listener : changeListenerList) {
            listener.stateChanged(e);
        }
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel activeDevicesPanel;
    private javax.swing.JLabel counterLabel;
    private org.visnow.vn.lib.basic.viewers.HapticViewer3D.gui.DevicesListGUI devicesCheckboxesGUI1;
    private org.visnow.vn.lib.basic.viewers.HapticViewer3D.gui.DevicesCheckboxesGUIBeanInfo devicesCheckboxesGUIBeanInfo1;
    private org.visnow.vn.lib.basic.viewers.HapticViewer3D.gui.DevicesCheckboxesGUIBeanInfo devicesCheckboxesGUIBeanInfo2;
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JLabel loosePointerLabel;
    private javax.swing.JLabel pickingStateLabel;
    // End of variables declaration//GEN-END:variables
    private int counter = 0;

    /**
     * Updates state of loose pointer and picking state. Could be used to show state of device
     * pointers.
     */
    @Override
    public void pointerStateChanged()
    {
        //TODO UNUSED: PointerStateListener - DELETE pointerStateChanged() or attach it to the Pointer3DViewBehavior
        ++counter;
        counterLabel.setText(String.valueOf(counter));
        //        pickingStateLabel.setText("pickingActive: " + String.valueOf(controller.getPickingState()));
        //        loosePointerLabel.setText("loosePointer:  " + String.valueOf(controller.getLoosePointer()));
    }

    /**
     * Called when GUI is no longer needed (probably HapticViewer3D is being deleted).
     */
    public void onDelete()
    {
        devicesCheckboxesGUI1.onDelete();
    }

    static class InputDevicePointerControllerError extends Exception
    {
    }
}
// revised.
